version: '3.3'


services:

  db:
    restart: always
    image: mariadb:10.7
    command: [
        "--character-set-server=utf8",
        "--collation-server=utf8_unicode_ci",
      ]
    ports:
      - "3307:3306"
    volumes:
      - ./mariadb:/var/lib/mysql
    environment:
      - MARIADB_DATABASE=${MARIADB_DATABASE}
      - MARIADB_USER=${MARIADB_USER}
      - MARIADB_PASSWORD=${MARIADB_PASSWORD}
      - MARIADB_ROOT_PASSWORD=${MARIADB_ROOT_PASSWORD}
    deploy:
      resources:
        limits:
          cpus: "4"
          memory: "8G"

  phpmyadmin:
    image: phpmyadmin
    restart: always
    links:
      - db
    environment:
      PMA_HOST: db
      PMA_PORT: 3306
    deploy:
      resources:
        limits:
          cpus: "0.5"
          memory: "0.5G"
 
  xtb_capture:
    restart: always
    build:
      context: .
      args:
        - SSH_PRIVATE_KEY
    links:
      - db
    volumes:
      - ./:/usr/src/app
    env_file: .env
    command: go run /usr/src/app/main.go xtb capture
    deploy:
      resources:
        limits:
          memory: "1G"

  web:
    restart: always
    build:
      context: .
      args:
        - SSH_PRIVATE_KEY
    links:
      - db
    volumes:
      - ./:/usr/src/app
    env_file: .env
    command: go run /usr/src/app/main.go core stall
    deploy:
      resources:
        limits:
          cpus: "8"
          memory: "8G"
